/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.covert.ReportTemplateCovert
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO
 *  com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO
 *  com.deepexi.scd.calculate.service.TemplateService
 *  com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum
 *  com.deepexi.scd.common.extensions.ExNumeric
 *  com.deepexi.spa.commons.utils.StringUtils
 *  org.apache.commons.collections.CollectionUtils
 */
package com.deepexi.scd.calculate.service.impl.report;

import com.deepexi.scd.calculate.covert.ReportTemplateCovert;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO;
import com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO;
import com.deepexi.scd.calculate.service.TemplateService;
import com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum;
import com.deepexi.scd.common.extensions.ExNumeric;
import com.deepexi.spa.commons.utils.StringUtils;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.Maps;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Collection;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.stream.Collectors;
import org.apache.commons.collections.CollectionUtils;

public class IndustryReport269
implements TemplateService {
    private static final String TEMPLATE_NAME = "industryTemplate269.ftl";
    protected static final String HFC_23 = "HFC-23";
    protected static final String FOSSIL_FUEL = "化石燃料燃烧";
    protected static final Map<String, Integer> ENERGY_CATEGORY_MAP = Maps.newHashMap();
    protected static final Map<String, String> SPECIAL_GAS_MAP = Maps.newHashMap();

    public void exportTemplate(ExportReportLayoutVO exportReportLayoutVO, Map<String, Object> map) {
        List all = (List)exportReportLayoutVO.getTableMap().get("ALL");
        List specialTotal = (List)exportReportLayoutVO.getTableMap().get("SPECIAL_TOTAL");
        map.put("tplName", TEMPLATE_NAME);
        map.put("totals", specialTotal);
        map.put("list", exportReportLayoutVO);
        map.put("annexedTable2", this.getAnnexedTable2(all));
        map.put("annexedTable3", this.getAnnexedTable3(all));
        map.put("annexedTable4", this.getAnnexedTable4(all));
        map.put("annexedTable5", this.getAnnexedTable5(all));
        map.put("annexedTable6", this.getAnnexedTable6(all));
    }

    public String getTemplateName() {
        return TEMPLATE_NAME;
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable2(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of(FOSSIL_FUEL), ImmutableList.of("化石燃料燃烧-氟化工"), ImmutableList.of(FOSSIL_FUEL), (String)"平均低位发热量", (String)"单位热值含碳量", (String)"含碳量计算结果");
        tableItems.forEach(table -> {
            List itemList = table.getItemList();
            if (CollectionUtils.isEmpty((Collection)itemList)) {
                return;
            }
            List collect = itemList.stream().sorted(this.getComparator()).collect(Collectors.toList());
            table.setItemList(collect);
        });
        return tableItems;
    }

    private Comparator<CalculateLayoutItemVO> getComparator() {
        return (a, b) -> {
            Integer sort;
            int aSum = 0;
            int bSum = 0;
            Optional<CalculateLayoutItemValueVO> aOption = a.getItemValueList().stream().filter(item -> CalculateItemValueTypeEnum.ENERGY_CATEGORY.getKey().equals(item.getValueType())).findFirst();
            Optional<CalculateLayoutItemValueVO> bOption = b.getItemValueList().stream().filter(item -> CalculateItemValueTypeEnum.ENERGY_CATEGORY.getKey().equals(item.getValueType())).findFirst();
            if (aOption.isPresent() && Objects.nonNull(sort = ENERGY_CATEGORY_MAP.get(aOption.get().getValue()))) {
                aSum = sort;
            }
            if (bOption.isPresent() && Objects.nonNull(sort = ENERGY_CATEGORY_MAP.get(bOption.get().getValue()))) {
                bSum = sort;
            }
            return aSum - bSum;
        };
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable3(List<CalculateReportLayoutObjectVO> all) {
        return ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("HCFC-22生产过程 HFC-23排放"), ImmutableList.of("HFC-23排放"), null, null, null);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable4(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("HCFC-22生产过程 HFC-23排放"), ImmutableList.of("HFC-23销毁"), null, null, null);
        tableItems.forEach(table -> {
            List itemList = table.getItemList();
            if (CollectionUtils.isEmpty((Collection)itemList)) {
                return;
            }
            itemList.forEach(item -> {
                if (Objects.nonNull(item.getTotalValueMap()) && Objects.nonNull(item.getTotalValueMap().get(HFC_23))) {
                    Map stringObjectMap = (Map)item.getTotalValueMap().get(HFC_23);
                    Object co2Value = stringObjectMap.get("二氧化碳排放当量");
                    BigDecimal value = Objects.isNull(co2Value) ? BigDecimal.ZERO : new BigDecimal(co2Value.toString());
                    this.coverCo2ItemValue(item.getItemValueList(), value);
                } else {
                    this.coverCo2ItemValue(item.getItemValueList(), BigDecimal.ZERO);
                }
            });
        });
        return tableItems;
    }

    private void coverCo2ItemValue(List<CalculateLayoutItemValueVO> list, BigDecimal data) {
        CalculateLayoutItemValueVO itemValue = new CalculateLayoutItemValueVO();
        itemValue.setValueCode("二氧化碳排放当量");
        itemValue.setValue(ExNumeric.formatValue((BigDecimal)data, (Integer)5));
        itemValue.setOriginValue(ExNumeric.formatValue((BigDecimal)data, (Integer)10));
        list.add(itemValue);
    }

    private List<CalculateReportLayoutObjectVO> getAnnexedTable5(List<CalculateReportLayoutObjectVO> all) {
        List tableItems = ReportTemplateCovert.getTableItems(all, ImmutableList.of("工业过程"), ImmutableList.of("HFCs/PFCs/SF₆生产过程副产物及逃逸排放"), ImmutableList.of("HFCs/PFCs/SF₆生产过程副产物及逃逸排放"), null, null, null);
        this.setGasType(tableItems);
        this.setSequenceNumber(tableItems);
        return tableItems;
    }

    private void setGasType(List<CalculateReportLayoutObjectVO> tableItems) {
        tableItems.forEach(table -> {
            List itemList = table.getItemList();
            if (CollectionUtils.isEmpty((Collection)itemList)) {
                return;
            }
            itemList.forEach(item -> {
                Optional<CalculateLayoutItemValueVO> first = item.getItemValueList().stream().filter(itemValue -> CalculateItemValueTypeEnum.CALCULATE_ITEM.getKey().equals(itemValue.getValueType())).findFirst();
                if (!first.isPresent()) {
                    return;
                }
                String value = first.get().getValue();
                CalculateLayoutItemValueVO calculateLayoutItemValueVO = new CalculateLayoutItemValueVO();
                calculateLayoutItemValueVO.setValueCode("排放的温室气体种类");
                calculateLayoutItemValueVO.setValueType("GAS");
                calculateLayoutItemValueVO.setValue(Objects.isNull(SPECIAL_GAS_MAP.get(value)) ? value : SPECIAL_GAS_MAP.get(value));
                item.getItemValueList().add(calculateLayoutItemValueVO);
                List collect = item.getItemValueList().stream().filter(itemValue -> CalculateItemValueTypeEnum.FACTOR.getKey().equals(itemValue.getValueType())).filter(itemValue -> StringUtils.isNotBlank((CharSequence)itemValue.getValue()) && new BigDecimal(itemValue.getValue()).compareTo(BigDecimal.ZERO) > 0).collect(Collectors.toList());
                BigDecimal reduce = collect.stream().map(itemValue -> new BigDecimal(itemValue.getValue())).reduce(BigDecimal.ZERO, BigDecimal::add).divide(new BigDecimal(collect.size()), 10, RoundingMode.HALF_UP);
                value = ExNumeric.formatValue((BigDecimal)reduce, (Integer)6);
                CalculateLayoutItemValueVO factor = new CalculateLayoutItemValueVO();
                factor.setValueCode("排放因子");
                factor.setValueType("FACTOR");
                factor.setValue(value);
                item.getItemValueList().add(factor);
            });
        });
    }

    private void setSequenceNumber(List<CalculateReportLayoutObjectVO> tableItems) {
        tableItems.forEach(table -> {
            List itemList = table.getItemList();
            if (CollectionUtils.isEmpty((Collection)itemList)) {
                return;
            }
            for (int i = 0; i < itemList.size(); ++i) {
                CalculateLayoutItemVO item = (CalculateLayoutItemVO)itemList.get(i);
                int value = i + 1;
                CalculateLayoutItemValueVO calculateLayoutItemValueVO = new CalculateLayoutItemValueVO();
                calculateLayoutItemValueVO.setValueCode("序号");
                calculateLayoutItemValueVO.setValueType("SEQUENCE");
                calculateLayoutItemValueVO.setValue(Integer.toString(value));
                item.getItemValueList().add(calculateLayoutItemValueVO);
            }
        });
    }

    private List<CalculateLayoutItemVO> getAnnexedTable6(List<CalculateReportLayoutObjectVO> all) {
        List filterItem = ReportTemplateCovert.getFilterItem(all, ImmutableList.of("电力热力"), ImmutableList.of("电力热力明细"), ImmutableList.of("电力购入输出明细", "热力购入输出明细"));
        ReportTemplateCovert.calculate((List)filterItem, (String)"购入量", (String)"输出量", (String)"净购入量", (String)"SUBTRACT");
        return filterItem;
    }

    static {
        ENERGY_CATEGORY_MAP.put("煤", 1);
        ENERGY_CATEGORY_MAP.put("油", 2);
        ENERGY_CATEGORY_MAP.put("气", 3);
        ENERGY_CATEGORY_MAP.put("电", 4);
        ENERGY_CATEGORY_MAP.put("热", 5);
        SPECIAL_GAS_MAP.put("高纯 SF6 (≥99.999%)", "SF6");
        SPECIAL_GAS_MAP.put("非高纯 SF6 (＜99.999%)", "SF6");
    }
}

